=== debian/watch ===
version=4
opts="mode=git" https://github.com/qv2ray/qv2ray.git \
   refs/tags/v([\d\.]+) debian uupdate
